; Internal DATA // Donnes internes

; Internal data macros
data_offset	set	0

rs	MACRO
\1	EQU	data_offset
data_offset	set	data_offset+\2
	ENDM

; Allocate memory on the stack and make the given register point to this area
; Example : ALLOCATE_MEM a6
ALLOCATE_MEM	MACRO
	lea	-data_offset(a7),a7
	move.l	a7,\1
		ENDM

; Desallocate memory
; Warning : the given register musn't be changed : it must be the same value than ALLOCATE given !
DALLOCATE_MEM	MACRO
	move.l	\1,a7
	lea	data_offset(\1),a7
		ENDM

; Section DATA
	rs	Test_adr,4			; Adress of the test table
	rs	Graph_adr,4			; Adress of the graph table
	rs	Level_adr,4			; Adress of the compressed level
	rs	Anim_tile_adr,4			; Adress of the animation-tiles table

	rs	Archive_hd,2			; handle of the archived data (shk)

	rs	Sprite_adr,4			; Adress of the sprite buffer
	rs	Sprite_end_adr,4		; Adress of the end of the sprite buffer

	rs	Clear_buffer_adr,4		; Adress of the clear buffer
	rs	Clear_level_adr,4		; Adress of the clear buffer for this sub-level
	rs	Sub_lev_x,1			; Sub_level X
	rs	Sub_lev_y,1			; Sub_level Y
	rs	Sub_lev_size,2			; = 2^Sx * Sy
	rs	Mask_x,2			; Mask =%00000..1111 with (Sx1 -1) of 1
	rs	Len_x,2				; 2^Sx

	rs	Gfx1_adr,4			; Adress of the tiles (gfx) of the plane A
	rs	Gfx2_adr,4			; Adress of the tiles (gfx) of the plane B

	rs	World_adr,4			; Adress of the current world
	rs	Level_no,2			; Current level in the current world
	rs	Save_adr,4			; Adress of the save file.

	rs	Start_x,2			; Start position X
	rs	Start_y,2			; Start position Y (doit suivre start_x)

	rs	Screen_1,4			; Adress of the 1st DScreen
	rs	Screen_2,4			; Adress of the 2nd DScreen
	rs	Select_s,2			; Current DScreen
	rs	DScreen_hd,2			; Hd of the DScreen allocated using HeapAlloc
	rs	Current_dscreen,4		; Adress of the current DScreen for some internal functions

	rs	Refresh_window,1		; Flag : Refresh the window ?
	rs	Exit,1				; Flag : Exit ? (Save, Break, ...)
	rs	Alignement,1			; Flag : Syncronize the scrolling with a 16x bit ?

	rs	Plan_mur,1			; Code of the current wall (P1 or P2)

	rs	Print_way,2
;	rs	Plan_min,1			; Min surface of the current P
;	rs	Plan_max,1			; max surface of the curent P

	rs	Current_y,2			; Internal data of 'Print' routine (Sorry, it isn't a global data ;)
	rs	Current_SIN,4			; Internal data for sprite_init

	rs	Plan_A_adr,4			; Adress of the plane A
	rs	Dhz_A_table,4			; Adress of the dhz table of the plane A
	rs	Hdz_A_table,4			; Adress of the Hdz table of the plane A
	rs	Plan_B_adr,4			; Adress of the plane B
	rs	Dhz_B_table,4			; Adress of the dhz table of the plane B
	rs	Hdz_B_table,4			; Adress of the Hdz table of the plane B
	
	rs	Plane_A_Xs_old,2		; Value of PLANE_XS_OLD & YS_OLD for use
	rs	Plane_A_Ys_old,2		; with check_sprites routine
	rs	Check_offset,2			; Internal data of 'check sprites' routine

	rs	Scroll_ax,2			; Offset to add to the current position of the Scrolling : X
	rs	Scroll_ay,2			; Same but y
	rs	Center_x,2			; From Sonc position, correction to get the position of the scrolling : X
	rs	Center_y,2			; Same but Y
	rs	Scroll_cpt,2			; Time before using Scroll_ay (Press Up/Down)
	rs	xmin,2				; Minimun positon of the scrolling
	rs	xmax,2				; Maximun position of the scrolling
	rs	ymin,2				; Minimun position of the scrolling
	rs	ymax,2				; Maximun postion of the scrolling

	rs	All_window,1			; Flag : Display all window ?
	rs	Calc_B,1			; Flag : Calculate the coordinate of plane B ?
	rs	Diff_y,1			; Difference between Plane_A and plane_B for y position = Int(ln(SyA/SyB)/ln(2))
	rs	Calc,1				; Calculator = ?

	rs	Ring,2				; Number of collected rings
	rs	Life,2				; Number of lifes
	rs	Score,4				; Current score
	rs	Ring_to_life,2			; limit to get a new extra-life
	rs	Gemme,2				; number of gemme
	rs	Water_level,2			; Level of the water

	rs	key,4				; Genlib Joypad
	rs	key_mask,4			; Joypad's mask

	rs	minute,2			; Min
	rs	seconde,2			; s
	rs	centieme,2			; s /100
	
	rs	speed_level,2			; Speed 

	rs	rand_seed,2			; Internal data for random function

						; Var for external programs
	rs	External_sprite_adr,4		; Adress of the external sprites program
	rs	Init_sprite_adr,4		; Adress of the init_sprite function
	rs	Destroy_sprite_adr,4		; Adress of the destroy_sprite function
	rs	Surface_table,4			; Adress of the surface table
	rs	Calc_surface_adr,4		; Adress of the calculate coordinate function
	rs	Random_adr,4			; Adress of the random function
	rs	Line_adr,4			; Adress of the line function
	rs	Circle_adr,4			; Adress of the circle function

	rs	Current_surfa,4			; Current surfa Tab
	rs	Current_surfb,4			; Current surfb Tab
	rs	Current_surfc,4			; Current surfc Tab
	rs	Current_surfd,4			; Current surfd Tab

	rs	PlaneB_X_old,2

	rs	Free_buffer,(2+4*64*4)		; Free buffer for put_big_sprite
						; Maximun : sprite : 64 x 64 pixels
