; *********************************************************************
; 			Abeille
; *********************************************************************

buzz_init:
	clr.w	Buzz_act(a5)
	; Choose for Vx 3 or -3
	moveq	#3,d1
	move.l	d6,d2
	swap	d2
	cmp.w	d0,d2
	bls.s	\done
		moveq	#-3,d1
\done:
	move.w	d1,Buzz_vx(a5)
	rts

buzz_exe:
	; Read X,Y
	move.w	Xj(a5),d0
	move.w	Yj(a5),d1
	; Test action
	tst.b	Buzz_act(a5)
	bne.s	\fire
		; Move it !
		add.w	Buzz_vx(a5),d0
		move.w	d0,Xj(a5)
		move.l	d6,d2
		swap	d2		; D2.w = X_perso
		sub.w	d0,d2
		bhi.s	\pos
			neg.w	d2
 \pos:		cmp.w	#64,d2		; D2.W = Abs(X - X_perso) < 64 ?
		bhi.s	\no_fire
			tst.b	Buzz_flag(a5)
			bne.s	\no_fire
				lea	Buzz_fire_img(Pc),a0
				move.l	a0,Gfx_adr(a5)
				st.b	Buzz_act(a5)	; Set fire action
				move.w	#30,Buzz_tmp(a5)	; Wait until
				bra.s	\done
\no_fire:	cmp.w	#160,d2
		bls.s	\done
			neg.w	Buzz_vx(a5)
			clr.b	Buzz_flag(a5)
			bra.s	\done

\fire:	; Wait...
	subq.w	#1,Buzz_tmp(a5)
	bne.s	\done
		lea	Buzz_img(Pc),a0
		move.l	a0,Gfx_adr(a5)
		move.w	#1,Buzz_act(a5)		; Act = 0 / Flag = 1
		move.w	Buzz_vx(a5),d3
		swap	d3
		move.w	#3,d3
		moveq	#SPR_EXTRA0,d2
		bsr	Init_sprite	; Init sprite fire
\done:

	; Determine sens (H Flipping)
	or.b	#%00000010,Drawing(a5)
	tst.w	Buzz_vx(a5)
	blt.s	\Ok
		and.b	#%11111101,Drawing(a5)
\Ok:	

	; Coordinate of the center of gravity
	add.w	#26/2,d0
	addq.w	#12/2,d1

	; Collision ?
	test_sonic_collision2.s d0,d1,26,12,d2,d3,Buzz_no_collision
	bra	Hurt
Buzz_no_collision:

	; Exit the screen ?
	test_exit_screen.s d0,d1,d2,Buzz_outside
	rts

Buzz_outside:
	move.w  Offset(a5),d0
	move.b  #OBJ_EXT9/4,0(a4,d0.w)
	bra	DestroySprite


Buzz_img:
	incbin "abeille.bin"
Buzz_fire_img:
	incbin "abeiltir.bin"
