#include <stdio.h>
#include <stdlib.h>

#define MAX_SURFACE 25
#define MAX_NEW_SURFACE 26

char cvt_tab[]= {
             0,1,2,-1,
             14,20,26,8,
             9,10,6,7,
             12,13,3,4,
             11,5
             };

char cvt2_tab[]= {
             0,1,2,-1,
             14,20,26,8,
             22,21,19,18,
             25,24,16,15,
             23,17
             };

void main(int argc, char *argv[])
{
 FILE *F;
 int i,num,no_surf,SizeX;
 unsigned char *a0, *a1;

 puts("Convert SMA level v0.28/0.30/0.32 to SMA level v0.34");

 if (argc != 3)
    {
     puts("Error: cvt leveltest.lvl sizeX");
     exit(1);
    }

 sscanf(argv[2],"%d",&SizeX);

 if (!(F=fopen(argv[1],"rb")))
    {
     printf("Error : can't open %s\n",argv[1]);
     exit(2);
    }
 if (!(a0 = a1 = malloc(sizeof(char) * 200000)))
    {
    puts("Error : memory");
    fclose(F);
    exit(3);
    }

 num = fread(a0,sizeof(char),200000,F);
 fclose(F);

 /* Conversion */
 printf("Conversion of %s (SizeX = %d)...\n",argv[1],SizeX);
 for(i=0 ; i < num ; i++,a1++)
    {
     // Test
     if (*a1 == 0)
        continue;

     if (*a1 > 3* MAX_SURFACE)
        *a1 += 3*(MAX_NEW_SURFACE - MAX_SURFACE);
     // Brique cassable
     else if ((*a1 == 3))
        *a1 = 141;
     // Surface
     else
         {
          // Recherche no surface
          if (*a1 >= 2*MAX_SURFACE+1)
             no_surf = 2;
          else if (*a1 >= MAX_SURFACE+1)
             no_surf = 1;
          else no_surf = 0;

          // Correction no surface
          *a1 -= no_surf * MAX_SURFACE;

          // Correction surface
          if ((*(a1-SizeX)==1) || (*(a1-2*SizeX)==1))
                *a1 = cvt2_tab[*a1];
                else
                *a1 = cvt_tab[*a1];

          // Restaure surface
          *a1 += no_surf * MAX_NEW_SURFACE;
         }
    }

 /* Fin de conversion */
 puts("Conversion done");

 if (!(F=fopen(argv[1],"wb")))
    {
     printf("Error : can't open %s (write)\n",argv[1]);
     exit(4);
    }
 fwrite(a0,sizeof(char),num,F);
 fclose(F);
 puts("Done !");
}

