/* Level converter */
#include "include.h"
#include "macro.h"
#include "editor.h"

#define TILE_BASE 25+3
#define MAX_SIZE 65536

 ub *graph;
 ub *test;
 ul sg=0,st=0;

ub search_link(ub grph, ul size)
{
 ul tab[256];
 ub tst;
 ub *a0;
 ub *a1;
 ul i;
 for (i = 0; i < 256 ; i++) tab[i] = 0;
 a0 = test, a1 = graph;
 for (i = 0 ; i < size ; i++, a1++, a0++)
       {
        if (*(a1) == grph) tab[ *(a0) ] +=1;
       }
 tst = 0;
 for ( i = 1 ; i < 256 ; i++) if (tab[i] > tab[tst]) tst = i;
 return tst;
}

ub create_level(LEVEL *L)
{
// FILE *F_out;
 FILE *F1, *F2;
 ub Name[512];
 ub temp[512];
 ul i,j;
 uw k,l;
 ub b;
 ub *a0;
 ub *a1;
 char **args;
 char **a2;

 printf("Create a new level : %s\n", L->Level_name);
 printf("Gfx1: %s Gfx2: %s\n",L->Graph1_file,L->Graph2_file);
 printf("Tab Test1: %s Graph1: %s Graph2: %s\n",L->Test_file,L->Gfx_file,L->Plan2);
 printf("Level: %u x %u Sub-level: %u x %u Plan2: %u x %u\n",L->Mx,L->My,L->Sx,L->Sy,L->Sx2,L->Sy2);
/* printf("Memory : %u bytes\n",3840*3+2*10000+3000+2*L->Sx*L->Sy+L->Mx*L->My/(8*L->Sx*L->Sy)+filesize(L->Grah1-file)+when(strcmp(L->Graph1_file,L->graph2_file),0,filesize(graph2_file));
*/
 graph = xalloc(sizeof(ub) * MAX_SIZE);
 test  = xalloc(sizeof(ub) * MAX_SIZE);

 F1    = xopen(L->Gfx_file,"rb");
 F2    = xopen(L->Test_file,"rb");
 sg = fread(graph, sizeof(ub), MAX_SIZE, F1);
 st = fread(test,  sizeof(ub), MAX_SIZE, F2);
 xclose(F2), xclose(F1);

 if (sg != st)
    {
     puts("Error : gfx file and test file have different size !");
     return -1;
    }

  if  ( ((L->Mx / L->Sx) * L->Sx != L->Mx) || ((L->My / L->Sy) * L->Sy != L->My) )
    {
    puts("Error : Sub-levels have incompatible size with level !");
    return -1;
    }

 if ( ((long)(L->Sx * L->Sy)) > 32768)
	puts("Warning : Sub-level's size > 32768, so it could crash !!");

 if (L->Sx2 < 32)
	puts("Warning : Plane B size X < 32 !");

 /* Create link table */
 printf("Create link table...");
 F1 = xopen("link.$$$","wb");
 for ( i = 0 ; i < 256 ; i++)
     temp[i] = search_link( i, L->Mx * L->My);
 fwrite(temp,sizeof(ub), 256, F1);
 xclose(F1);
 printf("Done !\n");

 /* Rewrite the test matrix using the link table */
 printf("ReWriting test...\n");
 a0 = graph;
 a1 = test;
 for (i = 00 ; i < L->Mx * L->My ; i++, a1++, a0++)
      if (*(a1) == temp[*a0])
          *(a1) = 255;

 /* Curring the 2 matrix (gfx and test) in many small ones */
 printf("Cutting source files...\n");
 for (j = 0 ; j < L->My / L->Sy ; j++)
        for (i = 0 ; i < L->Mx / L->Sx ; i++)
            {
            sprintf(Name,"l%ux%u.$$$",i,j);
            F1 = xopen(Name, "wb");
            for (k = 0 ; k < L->Sy ; k++)
                for (l = 0 ; l < L->Sx ; l++)
                    fwrite(graph + j * L->Mx * L->Sy + k * L->Mx + i * L->Sx + l,
                           sizeof(ub), 1, F1);
            for (k = 0 ; k < L->Sy ; k++)
                for (l = 0 ; l < L->Sx ; l++)
                    fwrite(test + j * L->Mx * L->Sy + k * L->Mx + i * L->Sx + l,
                           sizeof(ub), 1, F1);
            xclose(F1);
            }
 free(graph);
 free(test);

 /* Animation */
 F1 = xopen("anim.$$$","w");
 xclose(F1);

 /* Creation de la liste de fichier */
 a2 = args = xalloc(sizeof(ub *) * 256);
 k = 0;

// if (debug)
  //      {
        *(a2++) = "packer92.exe", k++;
        *(a2++) = "-n", k++;
    //    }
// else
//	*(a2++) = "shrink92.exe", k++;

 *(a2++) = L->Plan2, k++;
 *(a2++) = "link.$$$", k++;
 *(a2++) = "anim.$$$", k++;

 for (j = 0 ; j < L->My / L->Sy ; j++)
 for (i = 0 ; i < L->Mx / L->Sx ; i++)
	{
	a0 = xalloc(sizeof(char) * 15);
	sprintf(a0, "l%ux%u.$$$",i,j);
	*(a2++) = a0,k++;
	}
// if (debug)
        *(a2++) = "PackL.$$$", k++;
// else 
  //      *(a2++) = "-oPackL.$$$", k++;

 Name[0]=0;
 for(i = 0; i < k ; i++)
	{
	sprintf(temp,"%s ",args[i]);
	strcat(Name,temp);
	}
 printf(Name);

 exec_program(Name);
}

ub	finish_level(LEVEL *L,char *Output)
{
 FILE *F1;
 ub Name[512];
 ul i,j;
 ul len_data;
 ub b;
 ub *a0;

 // Donnees compresses
 F1 = xopen("packl.$$$","rb");
 len_data = fread(a0=xalloc(sizeof(ub) * MAX_SIZE),sizeof(ub),MAX_SIZE, F1);
 xclose(F1);

 /* Ecrit les donne de base... */
 F1 = xopen(Output,"wb");

 //1er fichier graphique + type
 for(i = 0 ; i < 8 ; i++) Name[i] = 0;
 for(i = 0 ; ((Name[i] = *(L->Graph1_file + i))) && (i<8); i++);
 fwrite(Name, sizeof(ub), 8, F1);
 b = 0;
 fwrite(&b, sizeof(ub), 1, F1);
 b = L->Type_P1;
 fwrite(&b, sizeof(ub), 1, F1);

 // 2nd fichier grahique + type
 for(i = 0 ; i < 8 ; i++) Name[i] = 0;
 for(i = 0 ; ((Name[i] = *(L->Graph2_file + i))) && (i<8); i++);
 fwrite(Name, sizeof(ub), 8, F1);
 b = 0;
 fwrite(&b, sizeof(ub), 1, F1);
 b = L->Type_P2;
 fwrite(&b, sizeof(ub), 1, F1);

 // Fichier sprite externe + fichier son
// for(i = 0 ; i < (9*2) ; i++) Name[i] = 0;
 for(i = 0 ; i < 8; i++) Name[i] = *(L->Sprite_file + i);
 Name[i] = 0;
 for(; i < (8+1+8); i++) Name[i] = *(L->Sound_file + i-8-1);
 Name[i] = 0;

 fwrite(Name, sizeof(ub), 2*9, F1);

 // Nom du niveau
 for(i = 0 ; i < 11 ; i++) Name[i] = 0;
 for(i = 0 ; ((Name[i] = *(L->Level_name+i)) != 0) && (i<11); i++);
 fwrite(Name, sizeof(ub), 11, F1);
 b = 0;
 fwrite(&b, sizeof(ub), 1, F1);

 // MX1 / MY1 / SX1 / SY1
 i = L->Mx / L->Sx, b = i;
 fwrite(&b, sizeof(ub), 1 , F1);
 i = L->My / L->Sy, b = i;
 fwrite(&b, sizeof(ub), 1 , F1);
 b = 32;
 for(i = 0 ,j = 1; i < 32 ; i++, j *= 2)
       if ( j == L->Sx) b = i;
 printf("Sub-level size X = 2^%u ",b);
 fwrite(&b, sizeof(ub), 1 , F1);
 b= L->Sy;
 fwrite(&b, sizeof(ub), 1 , F1);

 // Sx2 & Sy2
 b = 32;
 for(i = 0 ,j = 1; i < 32 ; i++, j *= 2)
       if ( j == L->Sx2) b = i;
 printf("Sub-level plan B size X = 2^%u\n",b);
 fwrite(&b, sizeof(ub), 1 , F1);
 b= L->Sy2;
 fwrite(&b, sizeof(ub), 1 , F1);

 // Start position
 i = (L->Startx % L->Sx) * 256 + (L->Startx / L->Sx);
 j = (L->Starty % L->Sy) * 256 + (L->Starty / L->Sy);
 fwrite(&i, sizeof(ub), 2, F1);
 fwrite(&j, sizeof(ub), 2, F1);

 // Extra-surface table
 fwrite(Name, sizeof(ub),8, F1);

 // Donnees compressees
 fwrite(a0, sizeof(ub), len_data, F1);
 xclose(F1);
 return 0;
}

