#include "include.h"
#include "macro.h"

#include "plane.h"
#include "ObjPlane.h"
 
void init_plane(Plane *P)
{
 int i;

 P->plane_file[0]=0;
 P->skip_byte = 0;
 P->tile_name[0]=0;
 P->link_file[0]=0;
 P->tile_no= 0;
 P->height = 0;
 P->length = 0;
 P->sub_height = 0;
 P->sub_length = 0;
 P->type = 2;
 P->xs = 0;
 P->ys = 0;
 P->list_no = 1;
 P->list_no2 = 0;
 P->list_s = 0;
 P->pl_tab = NULL;
 P->link_no = -1;
 P->Plink  = NULL;
 P->link_tab = NULL;
 for( i = 0 ; i < MAX_TILE ; i++)
      P->tile[i] = NULL;
}

void init_plane2(Plane *P)
{
 P->xs = 0;
 P->ys = 0;
 P->list_no = 1;
 P->list_no2= 0;
 P->list_s = 0;
}

void save_plane(Plane *P)
{
 static char *Titre="Save Plane-file as...";
 FILE *F1;

 if (file_select(Titre,P->plane_file, NULL) == 0)
       return;
 printf("Saving current Plane...\n");
 if ((F1 = fopen(P->plane_file,"wb")) == NULL)
    {
    printf("Error : can't open %s (w) \n", P->plane_file);
    return;
    }
 if (P->skip_byte !=0) fseek(F1, P->skip_byte, SEEK_CUR);    /* skip bytes */
 fwrite(P->pl_tab, sizeof(char), P->height * P->length, F1);
 fclose(F1);
 printf("Plane %s saved\n",P->plane_file);
 if (P->Plink)
	{
	Titre = "Save linked plane-file ?";
	save_plane(P->Plink);
	Titre = "Save plane-file as...";
	}
}

void open_plane(Plane *P)
{
 FILE *F1;
 if (file_select("Open Plane-file...",P->plane_file, NULL) == 0)
       return;
  printf("Opening Plane: % s ...\n",P->plane_file);
 if ((F1 = fopen(P->plane_file,"rb")) == NULL)
    {
    printf("Error : can't open %s (r) \n", P->plane_file);
    return;
    }
 if (P->skip_byte !=0) fseek(F1, P->skip_byte, SEEK_CUR);    /* skip bytes */
 fread(P->pl_tab, sizeof(char), P->height * P->length, F1);
 fclose(F1);
 printf("Plane %s opened\n",P->plane_file);
}


void open_link(Plane *P)
{
 FILE *F1;
 if (file_select("Open link-file...",P->link_file, NULL) == 0)
       return;
  printf("Opening link: % s ...\n",P->link_file);
 if ((F1 = fopen(P->link_file,"rb")) == NULL)
    {
    printf("Error : can't open %s (r) \n", P->link_file);
    return;
    }
 if (fread(P->link_tab, sizeof(char), 256, F1) != 256)
    {
    printf("Error :link table too small !\n");
    alert("Illegal link table !","","","ok",NULL,0,0);
    }
 fclose(F1);
 printf("Link %s opened\n",P->link_file);
}

void save_link(Plane *P)
{
 FILE *F1;
 if (file_select("Save link-file...",P->link_file, NULL) == 0)
       return;
  printf("Saving link: % s ...\n",P->link_file);
 if ((F1 = fopen(P->link_file,"wb")) == NULL)
    {
    printf("Error : can't open %s (w) \n", P->link_file);
    return;
    }
 fwrite(P->link_tab, sizeof(char), 256, F1);
 fclose(F1);
 printf("Link %s saved\n",P->link_file);
}

void print_Ptile(Plane *P, uw x, uw y, ub no)
{
 print_tile(x, y, no, P->taille, P->tile);
}

ub load_Ptile(Plane *P)
{
 return (P->tile_no = load_tile(P->tile_name, P->type, P->taille, P->tile));
}


ub select_link(Plane *P, ub x)
{
 uw y;
 ul i,j,k,t,a;
 ub cont= TRUE;
 if (P->Plink == NULL)
    {
     printf("Error : no link !\n");
     return x;
    }
 i = k = 0;
 t = P->Plink->taille;
 while (cont)
       {
       y = 0;
       j = i;
       clear(buffer);
       while ((y+t) < SCREEN_H)
             {
             print_Ptile(P->Plink, 50, y, j);
             if (j == k) print_selected_tile(50, y, j, P->taille);
             j++;
             y+= t+1;
             }
       scare_mouse();
       blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
       unscare_mouse();
       readkey();
       if (key[KEY_ESC]) cont=FALSE;
       if (key[KEY_UP])
           if (k > 0)
              {
              k--;
              if (i > k) i = k;
              }
       if (key[KEY_DOWN])
          if (k < P->Plink->tile_no)
             {
             k++;
             if (k >= j) i++;
             }
       if (key[KEY_PGUP])
	 for (a = 0 ; a < 15 ; a++)
	           if (k > 0)
        	      {
       		       k--;
       		       if (i > k) i = k;
              	      }
       if (key[KEY_PGDN])
	 for (a = 0 ; a < 15 ; a++)
          if (k < P->Plink->tile_no)
             {
             k++;
             if (k >= j) i++;
             }
       if (key[KEY_ENTER])
         {
          x = k;
          cont= FALSE;
         }
       }
 return x;
}



void edit_link(Plane *P)
{
 uw x,y;
 ul i,j,k,t,a;
 ub cont= TRUE;
 printf("Edit link...\n");
 if (P->Plink == NULL)
    {
     printf("Error : no link !\n");
     return ;
    }
 t = MAX(P->taille, P->Plink->taille);
 printf("MAX taille of link : %u \n", t);
 i = k = 0;
 while (cont)
       {
       y = 0;
       j = i;
       clear(buffer);
       while ((y+t) < SCREEN_H)
             {
             print_Ptile(P, 10, y, j);
             if (j == k) print_selected_tile(10, y, j, P->taille);
             print_Ptile(P->Plink, 100, y, *(P->link_tab + j));
             j++;
             y+= t+1;
             }
       scare_mouse();
       blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
       unscare_mouse();
       readkey();
       if (key[KEY_ESC]) cont=FALSE;
       if (key[KEY_UP])
          {
           if (k > 0)
              {
              k--;
              if (i > k) i = k;
              }
          }
       if (key[KEY_DOWN])
          {
          if (k < P->tile_no)
             {
             k++;
             if (k >= j) i++;
             }
          }
       if (key[KEY_PGUP])
	 for (a = 0 ; a < 15 ; a++)
	           if (k > 0)
        	      {
       		       k--;
       		       if (i > k) i = k;
              	      }
       if (key[KEY_PGDN])
	 for (a = 0 ; a < 15 ; a++)
          if (k < P->tile_no)
             {
             k++;
             if (k >= j) i++;
             }
       if (key[KEY_ENTER])
          *(P->link_tab + k) = select_link(P, *(P->link_tab + k));
       }
 i = alert("Save new link file ?","","","Yes","No",0,0);
 if (i == 1) save_link(P);
 return;
}
