#include "include.h"
#include "macro.h"

#include "plane.h" 
#include "ObjTile.h"
#include "ObjPlane.h"


/* On n'ajoute que ce qui est necessaire ! */
   BEGIN_GFX_DRIVER_LIST
   GFX_DRIVER_VBEAF
   GFX_DRIVER_VGA
//   GFX_DRIVER_MODEX
   GFX_DRIVER_VESA3
   GFX_DRIVER_VESA2L
   GFX_DRIVER_VESA2B
//   GFX_DRIVER_XTENDED
   GFX_DRIVER_VESA1
   END_GFX_DRIVER_LIST

   BEGIN_COLOR_DEPTH_LIST
   COLOR_DEPTH_8
//   COLOR_DEPTH_15
//   COLOR_DEPTH_16
//   COLOR_DEPTH_24
//   COLOR_DEPTH_32
   END_COLOR_DEPTH_LIST

   BEGIN_DIGI_DRIVER_LIST
//   DIGI_DRIVER_SOUNDSCAPE
//   DIGI_DRIVER_AUDIODRIVE
//   DIGI_DRIVER_SB
   END_DIGI_DRIVER_LIST

   BEGIN_MIDI_DRIVER_LIST
//   MIDI_DRIVER_AWE32
//   MIDI_DRIVER_DIGMID
//   MIDI_DRIVER_ADLIB
//   MIDI_DRIVER_MPU
//   MIDI_DRIVER_SB_OUT
   END_MIDI_DRIVER_LIST

   BEGIN_JOYSTICK_DRIVER_LIST
//   JOYSTICK_DRIVER_STANDARD
//   JOYSTICK_DRIVER_SIDEWINDER
//   JOYSTICK_DRIVER_GAMEPAD_PRO
//   JOYSTICK_DRIVER_SNESPAD
//   JOYSTICK_DRIVER_WINGWARRIOR
   END_JOYSTICK_DRIVER_LIST

// Allegro var
BITMAP  *buffer;

// Global vars
Plane	Plan;			// Plan ou on travaille
Plane	PLANE[MAX_PLANE];	// Sauvegarde
char	Project_name[MXS];	// Nom du fichier du projet

ub    on_continue = TRUE;
uw    current = 0;
uw    list_size = 4;

/* Box functions */
uw	xbox1=0,xbox2=0,ybox1=0,ybox2=0;

int open_project()
{
 FILE *F1;
 ul   i,j;

 if (alert("Open a new project","and lose this one ?","","Ok","Cancel",0,0) == 2)
    {
    return (0);
    }
 for(i = 0 ; i < MAX_PLANE ; i++)
       {
        free(PLANE[i].pl_tab);
        free(PLANE[i].link_tab);
        for(j = 0 ; j < MAX_TILE ; j++)
              free(PLANE[i].tile[j]);
       }
 current = 0;
 Plan = PLANE[0];

 if (file_select("Open project...", Project_name, NULL) == 0)
       return (0);
 printf("Opening project: % s ...\n", Project_name);
 if ((F1 = fopen(Project_name,"rb")) == NULL)
    {
    printf("Error : can't open %s (r) \n", Project_name);
    return (0);
    }
 if (fread(PLANE, sizeof(Plane), MAX_PLANE, F1) != MAX_PLANE)
    {
    printf("Error : Project seems to be illegal !\n");
    alert("Illegal project file !","","","ok",NULL,0,0);
    fclose(F1);
    init_plane(&Plan);
    for( i = 0 ; i < MAX_PLANE ; i++) init_plane(&(PLANE[i]));
    return (0);
    }
 fclose(F1);
 printf("Project %s opened\n", Project_name);


 for (i = 0 ; i < MAX_PLANE ; i++)
        {
        Plan = PLANE[i];
	printf("Opening plane in current project : %s.\n",Plan.plane_file);
	if (Plan.height * Plan.length)
        {
	if ((Plan.pl_tab = malloc(Plan.height * Plan.length * sizeof(ub))) == NULL)
           {
           printf("Not enought memory to allocate the plane table\n");
           alert("Memory full !", "Can't alocate the plane.","Crash ?","Ok",NULL,0,0);
           return FALSE;
           };
        for( j = 0 ; j < (Plan.length * Plan.height) ; j++)
               Plan.pl_tab[j] = 0;
        if (Plan.plane_file[0])    open_plane(&Plan);
        if (Plan.tile_name[0])     load_Ptile(&Plan);
	}
	else
	init_plane(&Plan);
        PLANE[i] = Plan;
        }
 for (i = 0 ; i < MAX_PLANE ; i++)
        {
        Plan = PLANE[i];
	printf("Open linked plane in current project: %s.\n",Plan.link_file);
        if (Plan.link_file[0])
           {
           if ((Plan.link_tab = malloc(sizeof(ub) * 256)) == NULL)
                   {
                   printf("Memory : link table ! \n");
                   alert("Error : memory","Not enoight free memory to allocate","a link table !","Ok",NULL,0,0);
                   return;
                   }
           open_link(&Plan);
	   Plan.Plink = &(PLANE[Plan.link_no]);
           }
        PLANE[i] = Plan;
        }
 Plan = PLANE[0];
 printf("Project %s opened !\n",Project_name);
 return 1;
}


void save_project()
{
 FILE *F1;
 PLANE[current] = Plan;

 if (file_select("Save project-file...", Project_name, NULL) == 0)
       return;
  printf("Saving project : % s ...\n", Project_name);
 if ((F1 = fopen(Project_name,"wb")) == NULL)
    {
    printf("Error : can't open %s (w) \n", Project_name);
    return;
    }
 fwrite(PLANE, sizeof(Plane), MAX_PLANE, F1);
 fclose(F1);
 printf("Project %s saved\n",Project_name);
}




void print_list()
{
 uw i = Plan.tile_no-Plan.list_s, j = 0, k = 0, no = Plan.list_s, pas = Plan.taille + 1;
 while (i>0)
       {
       print_Ptile(&Plan, SCREEN_W-pas*(j+1), pas*k, no);
       if (no == Plan.list_no)
         print_selected_tile(SCREEN_W-pas*(j+1), pas*k, no, Plan.taille);
       if (no == Plan.list_no2)
         print_selected2_tile(SCREEN_W-pas*(j+1), pas*k, no, Plan.taille);
       j++;
       if (j >= list_size)
          { k++;
            j = 0;
            if (pas * (k+1) > SCREEN_H)
               goto fin;
          }
       i--;
       no++;
       }
fin:
}

void print_tab()
{
 uw i,j, pas = Plan.taille + 1;
 sw x1=(xbox1-Plan.xs)*pas,y1=(ybox1-Plan.ys)*pas,x2=(xbox2-Plan.xs)*pas,y2=(ybox2-Plan.ys)*pas;
/* Put the case of the table */
 for( i = 0 ; (i < (SCREEN_W / pas) - (list_size)) && (i < Plan.length) ; i++)
      for (j = 0 ; (j < (SCREEN_H / pas)) && (j < Plan.height) ; j++)
          if (((j+Plan.ys) < Plan.height) && (i+Plan.xs < Plan.length))
             print_Ptile(&Plan, pas*i,pas*j,
                Plan.pl_tab[(j+Plan.ys)*Plan.length+i+Plan.xs]);
/* Put the H line and the V line */
 i=j=0;
 if (Plan.sub_length)
	while (i < Plan.length)
	{
	vline(buffer,(i-Plan.xs)*pas,0,SCREEN_H,LINE);
	i+=Plan.sub_length;
	}
 if (Plan.sub_height)
	while (j < Plan.height)
	{
	hline(buffer,0,(j-Plan.ys)*pas,SCREEN_W,LINE);
	j+=Plan.sub_height;
	}
/* Put the box */
 hline(buffer,x1,y1,x2,BOX);
 vline(buffer,x2,y1,y2,BOX);
 hline(buffer,x1,y2,x2,BOX);
 vline(buffer,x1,y1,y2,BOX);
}



/* Cut, Copy, Paste, Delete and Map functions */
uw	tampx=0,tampy=0;
ub	*tampon=NULL;
ub	tampon_flag=0;

void	set_xybox(void)
{
 uw register temp;
 if (xbox1>xbox2) temp = xbox1, xbox1 = xbox2, xbox2 = temp;
 if (ybox1>ybox2) temp = ybox1, ybox1 = ybox2, ybox2 = temp;
}

void	Copy(void)
{
 uw i,j;
 ub *a0;
 set_xybox();
 free(tampon);
 tampx=xbox2-xbox1;
 tampy=ybox2-ybox1;
 if (!(tampon = (ub *) malloc(sizeof(ub) * tampx * tampy * 2)))
	return;
 a0 = tampon;
 for(j=ybox1; j<ybox2 ; j++)
 for(i=xbox1; i<xbox2 ; i++)
	*(a0++)=Plan.pl_tab[j*Plan.length+i];
 if (Plan.link_no>=0)
	{
	for(j=ybox1; j<ybox2 ; j++)
	for(i=xbox1; i<xbox2 ; i++)
		*(a0++)=(Plan.Plink)->pl_tab[j*Plan.length+i];
	}
}

void	Delete(void)
{
 uw i,j;
 for(j=ybox1; j<ybox2 ; j++)
 for(i=xbox1; i<xbox2 ; i++)
	Plan.pl_tab[j*Plan.length+i]=0;
}

void	Cut(void)
{
 Copy();
 Delete();
}

void	Paste(void)
{
 uw i,j;
 ub *a0;
 set_xybox();
 a0 = tampon;
 for(j=ybox1; j<ybox1+tampy ; j++)
 for(i=xbox1; i<xbox1+tampx ; i++)
	if ((j< Plan.height) && (i< Plan.length))
		Plan.pl_tab[j*Plan.length+i]=*(a0++); 
 if (Plan.link_no >=0)
  {
	for(j=ybox1; j<ybox1+tampy ; j++)
	for(i=xbox1; i<xbox1+tampx ; i++)
	if ((j< Plan.height) && (i< Plan.length))
		(Plan.Plink)->pl_tab[j*Plan.length+i]=*(a0++); 
  }
}

void	Map(void)
{
 uw i,j,k,l;
 ub *a0;
 set_xybox();
 a0 = tampon;
 l = 0;
 for(j=ybox1; j<ybox2 ; j++)
 {
 k=0;
 for(i=xbox1; i<xbox2 ; i++)
	{
	Plan.pl_tab[j*Plan.length+i] = *(a0 + l*tampx + k);
	if (++k>=tampx) k =0;
	}
 if (++l>=tampy) l =0;
 }

 if (Plan.link_no >0)
  {
	l = 0;
	a0 += tampx * tampy;
	for(j=ybox1; j<ybox2 ; j++)
	{
	k=0;
	for(i=xbox1; i<xbox2 ; i++)
		{
		(Plan.Plink)->pl_tab[j*Plan.length+i] = *(a0 + l*tampx + k);
		if (++k>=tampx) k =0;
		}
	if (++l>=tampy) l =0;
	}
  }
}


/*Link functions /*/
void create_link()
{
 ul i,j,k;
 ub buf1[MXS],buf4[MXS];
 DIALOG the_dialog[] =
   {
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_shadow_box_proc, 100,  50,   220,  120,  255,  0,    0,    0,       0,    0,    NULL },                                   //0
   { d_text_proc,       110,  55,   180,   18,  255,   0,   0,    0,       0,    0,     "Select Link destination"},              //1
   { d_text_proc,       110,  75,   65,   18,  255,   0,   0,    0,       0,    0,     "LinkName: "},                             //2
   { d_edit_proc,       190,  75,   100 ,  18,   255,  0,    0,    0,       sizeof(buf4)-1, 0, buf4 },                           //3
   { d_text_proc,       110,  115,   50,   18,  255,   0,   0,    0,       0,    0,     "To plane: "},                            //4
   { d_edit_proc,       185,  115,   40 ,  18,   255,  0,    0,    0,       sizeof(buf1)-1, 0, buf1 },                           //5
   { d_button_proc,     110,  145,   60,   18,   255,  0,    0,    D_EXIT,  0,    0,    "OK" },                                  //6
   { d_button_proc,     220,  145,   60,   18,   255,  0,    0,    D_EXIT,  0,    0,    "Cancel" },                              //7
   { NULL,              0,    0,     0,     0,    0,    0,    0,    0,       0,    0,    NULL }
   };

 sprintf(buf1,"%d",Plan.link_no);
 sprintf(buf4,"%s",Plan.link_file);

 i = alert3("Plane maker "VERSION_STRING" by PpHd",
        "Link menu","","New/Open link","Edit link","Cancel",0,0,0);
 if (i == 3) return;
 if (i == 1)
    {
     i = alert3("Plane maker "VERSION_STRING" by PpHd",
        "Sub-Link menu","","New link","Open link","Cancel",0,0,0);
     if (i == 3) return;
     j =  popup_dialog(the_dialog, 1);
     if (j == 7) return;
     sscanf(buf1,"%d",&j);
     if ((Plan.height != PLANE[j].height) || (Plan.length != PLANE[j].length) )
        {
         printf("Error : Plane and linked plane don't have same size !\n");
         alert("ERROR","Incorrect size between planes","","Ok",NULL,0,0);
         return;
        }
     Plan.link_no = j;
     Plan.Plink = &(PLANE[Plan.link_no]);
     sprintf(Plan.link_file,"%s",buf4);
     free(Plan.link_tab);
     if ((Plan.link_tab = malloc(sizeof(ub) * 256)) == NULL)
        {
         printf("Memory : link table ! \n");
         alert("Error : memory","Not enoight free memory to allocate","a link table !","Ok",NULL,0,0);
         return;
        }
     for (j = 0 ; j < 256 ; j++) *(Plan.link_tab+j) = 0;
     if (i == 2)
        open_link(&Plan);
     return;
    }
  if ( i == 2) edit_link(&Plan);
 return;
}


/* Project menus functions */

void project_menu()
{
 int i;

 i = alert3("Plane maker "VERSION_STRING" by PpHd",
        "Project menu","","Open project","Save project","Cancel",0,0,0);
 if (i == 3) return;
 if (i == 2) save_project();
 else open_project();
}

char *listbox_getter(int index, int *list_size)
{
   static char *strings[] =
   {
      "Tile 8x8 4c",  "Tile 16x16 4c", "Tile 32x32 2c"
   };

   if (index < 0) {
      *list_size = 3;
      return NULL;
   }
   else
      return strings[index]; 
}

char *listbox_video(int index, int *list_size)
{
   static char *strings[] =
   {
      "320x200",  "640x480", "800x600", "1024x768"
   };

   if (index < 0) {
      *list_size = 4;
      return NULL;
   }
   else
      return strings[index]; 
}

ub select_option()
{
 ul i,j;
 ub blt = FALSE; // Reallocation du plan ?
 int ret;
 char buf1[MXS], buf2[MXS], buf3[MXS], buf4[MXS], buf5[MXS], buf6[MXS];
 DIALOG the_dialog[] =
   {
   /* (dialog proc)     (x)	(y)	(w)	(h)	(fg)  (bg)	(key)	(flags)	(d1)		(d2)	(dp) */
   { d_shadow_box_proc,	100,	50,	220,	200,	255,	0,	0,	0,	0,		0,	NULL },                                   //0
   { d_text_proc,	110,	55,	180,	18,	255,	0,	0,	0,	0,		0,	"Select plane features"},                //1
   { d_text_proc,	110,	75,	65,	18,	255,	0,	0,	0,	0,		0,	"TileFile:"},				//2
   { d_edit_proc,	190,	75,	100,	18,	255,	0,	0,	0,	sizeof(buf4)-1, 0,	buf4 },                           //3
   { d_text_proc,	110,	95,	65,	18,	255,	0,	0,	0,	0,		0,	"Map File:"},				//4
   { d_edit_proc,       190,	95,	100,	18,	255,	0,	0,	0,	sizeof(Plan.plane_file)-1, 0, Plan.plane_file },     //5
   { d_text_proc,       110,  115,   50,   18,  255,   0,   0,    0,       0,    0,     "Length:"},                              //6
   { d_edit_proc,       165,  115,   40 ,  18,   255,  0,    0,    0,       sizeof(buf1)-1, 0, buf1 },                           //7
   { d_text_proc,       205,  115,   50,   18,  255,   0,   0,    0,       0,    0,     "height:"},                              //8
   { d_edit_proc,       260,  115,   40 ,  18,   255,  0,    0,    0,       sizeof(buf2)-1, 0, buf2 },                           //9
   { d_text_proc,       110,  125,   50,   18,  255,   0,   0,    0,       0,    0,     "SubLen:"},                              //10
   { d_edit_proc,       165,  125,   40 ,  18,   255,  0,    0,    0,       sizeof(buf5)-1, 0, buf5 },                           //11
   { d_text_proc,       205,  125,   50,   18,  255,   0,   0,    0,       0,    0,     "SubHht:"},                              //12
   { d_edit_proc,       260,  125,   40 ,  18,   255,  0,    0,    0,       sizeof(buf6)-1, 0, buf6 },                           //13
   { d_list_proc,       105,  145,   150,  40,  255,  0,    0,    0,       1,    0,    listbox_getter },                         //14
   { d_button_proc,     110,  210,   60,   18,   255,  0,    0,    D_EXIT,  0,    0,    "OK" },                                   //15
   { d_button_proc,     220,  210,   60,   18,   255,  0,    0,    D_EXIT,  0,    0,    "Cancel" },                               //16
   { d_text_proc,       110,  190,   50,   18,  255,   0,   0,    0,       0,    0,     "Skip bytes:"},                          //17
   { d_edit_proc,       210,  190,   40 ,  18,   255,  0,    0,    0,       sizeof(buf3)-1, 0, buf3 },                           //18
   { NULL,              0,    0,     0,     0,    0,    0,    0,    0,       0,    0,    NULL }
   };

 sprintf(buf1,"%u",Plan.length);
 sprintf(buf2,"%u",Plan.height);
 sprintf(buf3,"%u",Plan.skip_byte);
 sprintf(buf4,"%s",Plan.tile_name);
 sprintf(buf5,"%u",Plan.sub_length);
 sprintf(buf6,"%u",Plan.sub_height);

 ret = popup_dialog(the_dialog, 1);

 if (ret == 16)
    return FALSE;

 switch (the_dialog[14].d1)
        {
         case 0: Plan.type   = 1;
                 Plan.taille = 8;
              break;
         case 1: Plan.type   =  2;
                 Plan.taille = 16;
              break;
         case 2: Plan.type   =  3;
                 Plan.taille = 32;
              break;
        }


 sscanf(buf1,"%u",&i); if (i != Plan.length) blt = TRUE;
 sscanf(buf2,"%u",&j); if (j != Plan.height) blt = TRUE;

 if (blt)
    {
    if (alert("Realloc plane table","Destroy current plane ?","","Ok","Cancel",0,0) == 2)
       return FALSE;
    if (Plan.pl_tab != NULL) free(Plan.pl_tab);
    if ((Plan.pl_tab = malloc(i * j * sizeof(ub))) == NULL)
       {
        printf("Not enought memory to allocate the plane table\n");
        alert("Memory full !", "Can't alocate the plane.","Crash ?","Ok",NULL,0,0);
        return FALSE;
       };
    Plan.length = i;
    Plan.height = j;
    for( i = 0 ; i < (Plan.length * Plan.height) ; i++)
          Plan.pl_tab[i] = 0;
    }

 if (strcmp(buf4, Plan.tile_name) != 0)
    {
     strcpy(Plan.tile_name, buf4);
     printf("Loading tiles.... ");

     if (!(load_Ptile(&Plan)))
        {
        printf("Error when loading and creating tiles\n");
        alert("Can't load tiles","","","ok",NULL,0,0);
        return FALSE;
        }
     printf("success !\n");
     }

 sscanf(buf3,"%u",&i);
 Plan.skip_byte = i;
 sscanf(buf5,"%u",&i);
 Plan.sub_length = i;
 sscanf(buf6,"%u",&i);
 Plan.sub_height = i;

 return TRUE;
}

void display_option()
{
 int ret;
 ul i;
 char buf4[MXS];
 DIALOG the_dialog[] =
   {
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_shadow_box_proc, 100,  50,   220,  150,  255,  0,    0,    0,       0,    0,    NULL },                                  //0
   { d_text_proc,       110,  55,   180,   18,  255,   0,   0,    0,       0,    0,     "Select display options"},              //1
   { d_text_proc,       110,  75,   180,   18,  255,   0,   0,    0,       0,    0,     "Display video mode"},                  //2
   { d_list_proc,       105,  95,   200,   40,   255,  0,    0,    0,      1,    0,    listbox_video },                             //3
   { d_button_proc,     110,  175,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    "OK" },                                  //4
   { d_button_proc,     220,  175,  60,   18,   255,  0,    0,    D_EXIT,  0,    0,    "Cancel" },                              //5
   { d_text_proc,       110,  145,   88,   12,   255,  0,    0,     0,       0,    0,    "List size:" },                        //6
   { d_edit_proc,       200,  145,   40 ,  18,   255,  0,    0,    0,       sizeof(buf4)-1, 0, buf4 },                          //7
   { NULL,              0,    0,    0,     0,    0,    0,    0,    0,       0,    0,    NULL }
   };

 sprintf(buf4,"%u",list_size);

 switch (SCREEN_W)
        {
        case 320: the_dialog[3].d1 = 0; break;
        case 640: the_dialog[3].d1 = 1; break;
        case 800: the_dialog[3].d1 = 2; break;
        case 1024: the_dialog[3].d1 = 3; break;
        }

 ret = popup_dialog(the_dialog, 1);

 if (ret != 4)
    return;

 switch (the_dialog[3].d1)
        {
        case 0 :
             if (SCREEN_W != 320)
                {
                set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0);
                goto change_resolution;
                }
             break;
        case 1 :
             if (SCREEN_W != 640)
                {
                set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
                goto change_resolution;
                }
             break;
        case 2 :
             if (SCREEN_W != 800)
                {
                set_gfx_mode(GFX_AUTODETECT, 800, 600, 0, 0);
                goto change_resolution;
                }
             break;
       case 3 :
             if (SCREEN_W != 1024)
                {
                set_gfx_mode(GFX_AUTODETECT, 1024, 768, 0, 0);
change_resolution:
                set_pallete(desktop_pallete);
                if (buffer != NULL)
                   {
                   printf("Free old buffer \n");
                   destroy_bitmap(buffer);
                   }
                if ((buffer = create_bitmap(SCREEN_W, SCREEN_H)) == NULL)
                   {
                   printf("Error when creating double-bufffer\n");
                   alert("Memory full","Can't allocate memory","for double-buffer","ok",NULL,0,0);
                   on_continue = FALSE;
                   return;
                   };
                printf("Double-buffer ok : %u bytes\n",SCREEN_W * SCREEN_H);
                clear(buffer);
                show_mouse(screen);
                }
                break;
        }


 sscanf(buf4,"%u",&i);
 list_size = i;


 printf("New display options. Screen mode : %u x %u , List size = %u \n",
         SCREEN_W, SCREEN_H, list_size);

 return;
}


void menu()
{
 char buf2[256];
 int i;

 sprintf(buf2,"Plane No %u/%u, (%u,%u)",
   current, MAX_PLANE,mouse_x/(Plan.taille+1)+Plan.xs,mouse_y/(Plan.taille+1)+Plan.ys);

 i = alert3("Plane maker "VERSION_STRING" by PpHd",
        buf2,"","New/Open","Quit","Cancel",0,0,0);

 if (i == 3)
    return;

 if (i == 2)
    {
     on_continue = FALSE;
     return;
    }

 i = alert3("Plane maker "VERSION_STRING" by PpHd",
           buf2,"","New plane","Open plane","Cancel",0,0,0);

 if (i == 3)
    return;

 if (!(select_option()))
    return;

 init_plane2(&Plan);

 if (i == 2)
    open_plane(&Plan);
 else
    for( i = 0 ; i < (Plan.length * Plan.height) ; i++)
          Plan.pl_tab[i] = 0;
}


void do_scrolling()
{
 ul i;
 uw pas = Plan.taille + 1;

 i = 1;
 if (key[KEY_CONTROL]) i =10;
 while (i-->0)
 {
     if ((key[KEY_UP]) && (Plan.ys>0) ) Plan.ys--;
     if ((key[KEY_DOWN]) && (Plan.ys < Plan.height-SCREEN_H/pas) ) Plan.ys++;
     if ((key[KEY_LEFT]) && (Plan.xs>0)) Plan.xs--;
     if ((key[KEY_RIGHT]) && (Plan.xs < Plan.length-SCREEN_W/pas+list_size)) Plan.xs++;
     if ((key[KEY_PGUP]) && (Plan.list_s > 0))
                         {
                         Plan.list_s-=list_size;
                         if (Plan.list_s < 0) Plan.list_s = 0;
                         }
     if ((key[KEY_PGDN]) && (Plan.list_s < (Plan.tile_no - (SCREEN_H / pas) * list_size)))
                         Plan.list_s += list_size;
 }
     if ( (key[KEY_PLUS_PAD]) && (current < MAX_PLANE) )
                  {
                   PLANE[current] = Plan;
                   current++;
                   Plan = PLANE[current];
                  }
     if ( (key[KEY_MINUS_PAD]) && (current > 0) )
                  {
                  PLANE[current] = Plan;
                  current--;
                  Plan = PLANE[current];
                  }
     if (key[KEY_F1])
        alert("F1:help F2:save F3:Disp F4:link F5:prjct ESC: opts",
              "Up.Down.Left.Right:scroll plane X,C,V,B,D:Cut, ...",
              "PUP.PDOWN:scroll list, +.-: change plane, SPACE:Box",
                   "Ok",NULL,0,0);
     if (key[KEY_F2]) save_plane(&Plan);
     if (key[KEY_F3]) display_option();
     if (key[KEY_F4]) create_link();
     if (key[KEY_F5]) project_menu();
     if (key[KEY_F6])
                     {
                      set_gfx_mode(GFX_TEXT, 80, 25, 0, 0);
                      printf("Press any key to continue...\n");
                      readkey();
                      set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
                      set_pallete(desktop_pallete);
                      show_mouse(screen);
                      }
     if (key[KEY_ESC]) menu();
	
	if (key[KEY_X]) Cut();
	if (key[KEY_C]) Copy();
	if (key[KEY_V]) Paste();
	if (key[KEY_B]) Map();
	if (key[KEY_D]) Delete();
	if ((key[KEY_E]) && (Plan.link_no>=0))
		Plan.Plink->xs = Plan.xs, Plan.Plink->ys=Plan.ys;
}

void update_tab()
{
 uw pas = Plan.taille + 1;
 uw i = (mouse_x / pas), j = (mouse_y / pas);

 /* Ne concerne pas le tableau (souris au-dehors)*/
 if (mouse_x >= (SCREEN_W - pas * list_size))
	return;

 /* Barre d'espace appuye ! */
 if (key[KEY_SPACE])
	{
	if (tampon_flag)
	xbox2 = i + Plan.xs, ybox2 = Plan.ys + j;
	else xbox1 = i + Plan.xs, ybox1 = j + Plan.ys, xbox2 = xbox1, ybox2 = ybox2, tampon_flag = 1;
	return;
	} 
 tampon_flag = 0;

 /* Un seul des deux boutons ? */
 if (mouse_b & 1)
    {
     Plan.pl_tab[Plan.length*(j+Plan.ys)+i+Plan.xs] = Plan.list_no;
     if (Plan.link_no >=0)
        (PLANE[Plan.link_no]).pl_tab[Plan.length*(j+Plan.ys)+i+Plan.xs] =
              *(Plan.link_tab + Plan.list_no);
    }
 if (mouse_b & 2)
    {
     Plan.pl_tab[Plan.length*(j+Plan.ys)+i+Plan.xs] = Plan.list_no2;
     if (Plan.link_no >=0)
        (PLANE[Plan.link_no]).pl_tab[Plan.length*(j+Plan.ys)+i+Plan.xs] =
              *(Plan.link_tab + Plan.list_no2);
    }
}

void update_list()
{
 uw pas = Plan.taille + 1;
 if ( (mouse_b & 1) && (mouse_x > (SCREEN_W - pas * list_size)) )
    {
     uw i = ((SCREEN_W-mouse_x) / pas), j = (mouse_y / pas);
     Plan.list_no = list_size * j + i+Plan.list_s;
    }
 if ( (mouse_b & 2) && (mouse_x > (SCREEN_W - pas * list_size)) )
    {
     uw i = ((SCREEN_W-mouse_x) / pas), j = (mouse_y / pas);
     Plan.list_no2 = list_size * j + i+Plan.list_s;
    }
}







int main(int argc, char *argv[])
{
 int i=0;

 puts("Plane maker v"VERSION_STRING);

 printf("Rapport du programme "__FILE__"\nCompilation du "__DATE__"  , "__TIME__"\nVersion no "VERSION_STRING"\n");

 // Allegro
 printf("Allegro...\n");
 allegro_init();
 install_keyboard();
 install_mouse();
 install_timer();

 if (argc!=3)
 set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
 else
 set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0);

 set_pallete(desktop_pallete);

 printf("Initialisation d'allegro termin !\n");

 /* double buffer the animation */
   if ((buffer = create_bitmap(SCREEN_W, SCREEN_H)) == NULL)
      {
       printf("Error when creating double-bufffer\n");
       return -1;
      };
 printf("Double-buffer ok !\n");

 for(i = 0 ; i < SCREEN_H ; i++)
       hline(screen, 0, i, SCREEN_W, i);

 init_plane(&Plan);
 for( i = 0 ; i < MAX_PLANE ; i++) init_plane(&(PLANE[i]));

 if (argc >= 2)
	{
	strcpy(Project_name,argv[1]);
	open_project();
	}
 else
	{
	 if (!(select_option()))
        	on_continue = FALSE;
 	 if (exists(Plan.plane_file))
                open_plane(&Plan);
	}
 show_mouse(screen);

 while (on_continue)
   {
    clear(buffer);
    do_scrolling();
    update_tab();
    update_list();

    print_list();
    print_tab();

    vsync();
    scare_mouse();
    blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
    unscare_mouse();

    while (!(keypressed()) && (!(mouse_b & 1)) && (!(mouse_b & 2)) && on_continue && (!tampon_flag));
    if (keypressed()) readkey();		/* On vide le buffer clavier */
    };

 allegro_exit();
 puts("By !");

 return 0;
};


